/***
 * Excerpted from "No Fluff Just Stuff 2007",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/nfjs07 for more book information.
***/
package com.acme.client;

// [snip]

public class LoginApplication 
   implements EntryPoint, HistoryListener {
  // [big snip]

  private void loadLoginView() {
    // [snip]

   final Label errorMsg = new Label();  
    errorMsg.setVisible(false);
    RootPanel.get().add(errorMsg);

   // [snip]
    button.addClickListener(new ClickListener() {
      public void onClick(Widget sender) {
         LoginServiceAsync ls = (LoginServiceAsync)
            GWT.create(LoginService.class);
         ServiceDefTarget target = (ServiceDefTarget)ls;
         target.setServiceEntryPoint(GWT.getModuleBaseURL() +
                                   "/loginService");
         
         ls.isValidLogin(nameTextbox.getText(),
                       passwordTextbox.getText(),
                       new AsyncCallback() {
         public void onSuccess(Object result) {
            if (true == ((Boolean)result).booleanValue()) {
               History.newItem(WELCOME_STATE);
            }
            else {
               errorMsg.setText(constants.errorMsg());
               errorMsg.setVisible(true);
            }
         }
         public void onFailure(Throwable caught) {
            Window.alert("rpc call failed: " + caught.getMessage());
         }
         });
      }
    });
    // [snip]
  }
}
