#---
# Excerpted from "No Fluff Just Stuff 2007",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/nfjs07 for more book information.
#---
# VARIABLES
set :application, "main_website"
set :repository, "http://svn.davebock.com/projects/#{application}

# ROLES
role :web, "www.davebock.com"
role :app, "www.davebock.com"
role :db, "databases.davebock.com"

# TASKS
task :restart_apache, :role => :web do
  run "/sbin/service httpd restart"
end

task :clear_sessions, :role => :db do
  run "cd #{current_path} && rake db:sessions:clear"
end

