/***
 * Excerpted from "No Fluff Just Stuff 2007",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/nfjs07 for more book information.
***/
package com.acme.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.user.client.ui.*;

public class LoginApplication implements EntryPoint {
  public void onModuleLoad() {
    final Label loginPrompt = new Label("Please log in");
    final Grid grid = new Grid(3,2);
    final Label namePrompt = new Label("Name");    
    final TextBox nameTextbox = new TextBox();
    final Label passwordPrompt = new Label("Password");    
    final PasswordTextBox passwordTextbox = new PasswordTextBox();
    final Button button = new Button("Login");

    loginPrompt.addStyleName("loginPrompt");
    nameTextbox.addStyleName("nameField");
    passwordTextbox.addStyleName("passwordField");

    RootPanel.get().add(loginPrompt);
    
    grid.setWidget(0, 0, namePrompt); // 0, 0 == row, column
    grid.setWidget(0, 1, nameTextbox);

    grid.setWidget(1, 0, passwordPrompt);
    grid.setWidget(1, 1, passwordTextbox);
    
    grid.setWidget(2, 0, button);
    
    RootPanel.get().add(grid);
  }
}
